var Channel = require("./channel");

const chs = ":"; // Channel separator

class EventualContext {

	constructor(eventual) {
		this.version = "Context MAP version";
		this.eventual = eventual;
		//this.listeners = new Map();
		this.listeners = {}; // Flat map
		this.watchers = {};
	}
	destroy() {
		this.eventual.destroyContext(this);
	}
	channel(name) {
		return new Channel(this,name);
	}
	get(name,create) {
		if(!this.listeners[name] && create) {
			var o = {listeners:{},callbacks:[]};
			this.listeners[name]= o;
			return o;
		}
		return this.listeners[name];

		/*var nodes = name.split(chs);
		var cur = this;
		for(var v of nodes ) {
			if(cur.listeners[v] == undefined) {
				if(create == undefined) { return null; }
				cur.listeners[v] = {listeners:{},callbacks:[]}
			}
			cur = cur.listeners[v]; // next;
		};
		return cur;*/
	}
	getCallbacks(name) {
		var listener = this.get(name);
		if(listener==null) return [];	
		return listener.callbacks;
	}

	getWatchers(name) {
		return this.watchers[name] || [];
	}
		on(name,callback,order = 0) {
		var listener = this.get(name,true);
		listener.callbacks.push({name,callback:callback,order});
	}
	emit(name,...args) {
		return this.eventual.emit(name,...args);
	}
	// Watcher features
	watch(name,callback) {
		if(this.watchers[name]== undefined) this.watchers[name]= [];
		this.watchers[name].push(callback);

		callback(this.eventual._events.store[name]);
	}
	set(name,value) {
		this.eventual.set(name,value);
	}
	unset(name) {
		this.eventual.unset(name);
	}

}

module.exports = EventualContext;
